Package: prettycode
Title: Pretty Print R Code in the Terminal
Version: 1.1.0
Author: Gábor Csárdi
Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
Description: Replace the standard print method for functions with one that
    performs syntax highlighting, using ANSI colors, if the terminal
    supports them.
License: MIT + file LICENSE
LazyData: true
URL: https://github.com/r-lib/prettycode#readme
BugReports: https://github.com/r-lib/prettycode/issues
RoxygenNote: 6.1.0
Imports: crayon, utils
Suggests: covr, mockery, rstudioapi, testthat, withr
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2019-12-16 13:01:04 UTC; gaborcsardi
Repository: CRAN
Date/Publication: 2019-12-16 14:00:06 UTC
Built: R 4.6.0; ; 2026-04-25 17:37:58 UTC; unix

Package: prettycode
Title: Pretty Print R Code in the Terminal
Version: 1.1.0
Author: Gábor Csárdi
Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
Description: Replace the standard print method for functions with one that
    performs syntax highlighting, using ANSI colors, if the terminal
    supports them.
License: MIT + file LICENSE
LazyData: true
URL: https://github.com/r-lib/prettycode#readme
BugReports: https://github.com/r-lib/prettycode/issues
RoxygenNote: 6.1.0
Imports: crayon, utils
Suggests: covr, mockery, rstudioapi, testthat, withr
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2019-12-16 13:01:04 UTC; gaborcsardi
Repository: CRAN
Date/Publication: 2019-12-16 14:00:06 UTC

# prettycode

> Pretty Print R Code in the Terminal

[![Linux Build Status](https://travis-ci.org/r-lib/prettycode.svg?branch=master)](https://travis-ci.org/r-lib/prettycode)
[![Windows Build status](https://ci.appveyor.com/api/projects/status/github/r-lib/prettycode?svg=true)](https://ci.appveyor.com/project/gaborcsardi/prettycode)
[![](http://www.r-pkg.org/badges/version/prettycode)](http://www.r-pkg.org/pkg/prettycode)
[![CRAN RStudio mirror downloads](http://cranlogs.r-pkg.org/badges/prettycode)](http://www.r-pkg.org/pkg/prettycode)
[![Coverage Status](https://img.shields.io/codecov/c/github/r-lib/prettycode/master.svg)](https://codecov.io/github/r-lib/prettycode?branch=master)

Replace the standard print method for functions with one that performs
syntax highlighting, using ANSI colors, if the terminal supports them.

## Installation

```r
install.packages("prettycode")
```

## Usage

Just call `prettycode::prettycode()` and start printing functions to the
screen. Long functions are automatically paged using the default pager.

![](/inst/screenshot.png)

## License

MIT © Gábor Csárdi

#' Pretty Print R Code in the Terminal
#'
#' Replace the standard print method for functions with one that performs
#' syntax highlighting, using ANSI colors, if the terminal supports them.
#'
#' @export

prettycode <- function() {
  register_s3_method("prettycode", "print", "function", print.function)
  if (! obj_name %in% search()) {
    env <- new.env(parent = emptyenv())
    env$print.function <- print.function
    env$`!` <- exclam
    do.call("attach", list(env, name = obj_name))
  }
}

register_s3_method <- function(pkg, generic, class, fun = NULL) {
  stopifnot(is.character(pkg), length(pkg) == 1)
  envir <- asNamespace(pkg)

  stopifnot(is.character(generic), length(generic) == 1)
  stopifnot(is.character(class), length(class) == 1)
  if (is.null(fun)) {
    fun <- get(paste0(generic, ".", class), envir = parent.frame())
  }
  stopifnot(is.function(fun))


  if (pkg %in% loadedNamespaces()) {
    registerS3method(generic, class, fun, envir = envir)
  }

  # Always register hook in case package is later unloaded & reloaded
  setHook(
    packageEvent(pkg, "onLoad"),
    function(...) {
      registerS3method(generic, class, fun, envir = envir)
    }
  )
}

#' Print a function with syntax highlighting
#'
#' To turn on pretty printing of functions, you need to call
#' `prettycode::prettycode()`. It might be a good idea to call it
#' from your `.Rprofile`.
#'
#' @param x Function to print.
#' @param useSource Whether to use the stored source code, if available.
#' @param style The highlight style to use, see [default_style()].
#' @param ... Not used currently, for compatibility with the `print`
#'   generic.
#' @return The function, invisibly.
#'
#' @importFrom utils capture.output

print.function <- function(x, useSource = TRUE,
                           style = default_style(), ...) {

  if (!can_pretty_print()) return(base::print.function(x, useSource))

  srcref <- getSrcref(x)
  src <- if (useSource && ! is.null(srcref)) {
    as.character(srcref)
  } else {
    deparse(x)
  }

  err <- FALSE
  hisrc <- tryCatch(
    highlight(src, style = style),
    error = function(e) err <<- TRUE)
  if (err) return(base::print.function(x, useSource))

  ## Environment of the function
  hisrc <- c(hisrc, capture.output(print(environment(x))))

  if (!should_page(hisrc)) {
    cat(hisrc, sep = "\n")

  } else {
    cat(hisrc, sep = "\n", file = tmp <- tempfile())
    on.exit(unlink(tmp), add = TRUE)
    less <- Sys.getenv("LESS", NA_character_)
    if (is.na(less)) {
      on.exit(Sys.unsetenv("LESS"), add = TRUE)
    } else {
      on.exit(Sys.setenv(LESS = less), add = TRUE)
    }
    Sys.setenv(LESS = paste0("-R", if (!is.na(less)) less))
    file.show(tmp)
  }

  invisible(x)
}

obj_name <- "tools:prettycode"

exclam <- function(x) {
  if (is.function(x)) print.function(x) else base::`!`(x)
}

.onUnload <- function(package) {
  if (obj_name %in% search()) {
    do.call("detach", list(obj_name))
  }
}

#' @importFrom crayon has_color

can_pretty_print <- function() {
  has_color()
}

num_lines <- function() {
  tryCatch(
    as.numeric(system("tput lines", intern = TRUE)),
    error = function(e) NA_integer_
  )
}

should_page <- function(src) {
  is_interactive() && is_terminal() && length(src) > num_lines()
}

context("print")

test_that("print without color support", {

  mockery::stub(print.function, "should_page", FALSE)
  mockery::stub(print.function, "can_pretty_print", FALSE)

  f <- function() { }
  expect_output(
    withr::with_options(list(crayon.enabled = TRUE), print.function(f)),
    "function[(][)] { }"
  )
})


test_that("print without color support 2", {

  called <- FALSE
  mockery::stub(print.function, "should_page", FALSE)
  mockery::stub(print.function, "can_pretty_print", FALSE)
  mockery::stub(
    print.function,
    "base::print.function",
    function(...) called <<- TRUE
  )

  withr::with_options(list(crayon.enabled = TRUE), print.function(ls))

  expect_true(called)
})

test_that("print with color support", {

  args <- NULL
  mockery::stub(print.function, "should_page", FALSE)
  mockery::stub(print.function, "can_pretty_print", TRUE)
  mockery::stub(print.function, "cat", function(...) args <<- list(...))

  f <- function() { 1 + 2 }
  withr::with_options(
    list(crayon.enabled = TRUE),
    print.function(f)
  )
  expect_true(crayon::has_style(paste(args[[1]], collapse = "\n")))
})

test_that("print with color support 2", {

  args <- NULL
  mockery::stub(print.function, "should_page", FALSE)
  mockery::stub(print.function, "can_pretty_print", TRUE)
  mockery::stub(print.function, "cat", function(...) args <<- list(...))

  withr::with_options(
    list(crayon.enabled = TRUE),
    print.function(ls)
  )
  expect_true(crayon::has_style(paste(args[[1]], collapse = "\n")))
})

test_that("pager", {

  cn <- NULL
  mockery::stub(print.function, "should_page", TRUE)
  mockery::stub(print.function, "can_pretty_print", TRUE)
  mockery::stub(print.function, "file.show", function(f) cn <<- readLines(f))

  f <- function() { 1 + 2 }
  withr::with_options(
    list(crayon.enabled = TRUE),
    print.function(f)
  )

  expect_true(crayon::has_style(paste(cn, collapse = "\n")))
})

test_that("can_pretty_print", {
  expect_identical(can_pretty_print(), crayon::has_color())
})

test_that("num_lines", {
  mockery::stub(num_lines, "system", "42")
  expect_equal(num_lines(), 42)
})

test_that("should_page 1", {
  mockery::stub(should_page, "is_interactive", FALSE)
  expect_false(should_page())
})

test_that("should_page 2", {
  mockery::stub(should_page, "is_interactive", FALSE)
  expect_false(should_page(1:100))
})

test_that("should_page 3", {
  mockery::stub(should_page, "is_interactive", TRUE)
  mockery::stub(should_page, "is_terminal", FALSE)
  expect_false(should_page(1:100))
})

test_that("should_page 4", {
  mockery::stub(should_page, "is_interactive", TRUE)
  mockery::stub(should_page, "is_terminal", TRUE)
  mockery::stub(should_page, "num_lines", 50)
  expect_false(should_page(1:10))
})

test_that("should_page 5", {
  mockery::stub(should_page, "is_interactive", TRUE)
  mockery::stub(should_page, "is_terminal", TRUE)
  mockery::stub(should_page, "num_lines", 50)
  expect_true(should_page(1:100))
})

test_that("fallback", {
  called <- FALSE
  mockery::stub(print.function, "base::print.function",
                function(...) called <<- TRUE)

  f <- new("function")
  body(f) <- substitute(.External(x), list(x = new("externalptr")))
  capture_output(print.function(f))
  expect_true(called)
})

library(css)

rstudio_theme_details_map <- list(
  "ambiance" = list(name = "Ambiance", isDark = TRUE),
  "chaos" = list(name = "Chaos", isDark = TRUE),
  "chrome" = list(name = "Chrome", isDark = FALSE),
  "clouds" = list(name = "Clouds", isDark = FALSE),
  "clouds_midnight" = list(name = "Clouds Midnight", isDark = TRUE),
  "cobalt" = list(name = "Cobalt", isDark = TRUE),
  "crimson_editor" = list(name = "Crimson Editor", isDark = FALSE),
  "dawn" = list(name = "Dawn", isDark = FALSE),
  "dracula" = list(name = "Dracula", isDark = TRUE),
  "dreamweaver" = list(name = "Dreamweaver", isDark = FALSE),
  "eclipse" = list(name = "Eclipse", isDark = FALSE),
  "idle_fingers" = list(name = "Idle Fingers", isDark = TRUE),
  "katzenmilch" = list(name = "Katzenmilch", isDark = FALSE),
  "kr_theme" = list(name = "Kr Theme", isDark = TRUE),
  "material" = list(name = "Material", isDark = TRUE),
  "merbivore" = list(name = "Merbivore", isDark = TRUE),
  "merbivore_soft" = list(name = "Merbivore Soft", isDark = TRUE),
  "mono_industrial" = list(name = "Mono Industrial", isDark = TRUE),
  "monokai" = list(name = "Monokai", isDark = TRUE),
  "pastel_on_dark" = list(name = "Pastel On Dark", isDark = TRUE),
  "solarized_dark" = list(name = "Solarized Dark", isDark = TRUE),
  "solarized_light" = list(name = "Solarized Light", isDark = FALSE),
  "textmate" = list(name = "Textmate (default)", isDark = FALSE),
  "tomorrow" = list(name = "Tomorrow", isDark = FALSE),
  "tomorrow_night" = list(name = "Tomorrow Night", isDark = TRUE),
  "tomorrow_night_blue" = list(name = "Tomorrow Night Blue", isDark = TRUE),
  "tomorrow_night_bright" = list(name = "Tomorrow Night Bright", isDark = TRUE),
  "tomorrow_night_eighties" = list(name = "Tomorrow Night 80s", isDark = TRUE),
  "twilight" = list(name = "Twilight", isDark = TRUE),
  "vibrant_ink" = list(name = "Vibrant Ink", isDark = TRUE),
  "xcode" = list(name = "Xcode", isDark = FALSE)
)

rstudio_theme_url_template <- paste0(
  "https://raw.githubusercontent.com/",
  "rstudio/rstudio/master/src/cpp/session/resources/themes/%s.rstheme"
)

## A set of operator colors to use, for each theme. Should match the name
## of the theme file in ace.
## We need to explicity set themes that should be overridden with the default
## vaue to NULL
operator_theme_map <- list(
   "solarized_light" = "#93A1A1",
   "solarized_dark" = "#B58900",
   "twilight" = "#7587A6",
   "idle_fingers" = "#6892B2",
   "clouds_midnight" = "#A53553",
   "cobalt" = "#BED6FF",
   "kr_theme" = "#A56464",
   "clouds" = NULL,
   "dawn" = NULL,
   "eclipse" = NULL,
   "katzenmilch" = NULL,
   "merbivore" = NULL,
   "merbivore_soft" = NULL,
   "monokai" = NULL,
   "pastel_on_dark" = NULL,
   "vibrant_ink" = NULL,
   "xcode" = NULL
)

## Similarly, colors for keywords that we might override.
keyword_theme_map <- list(
   "eclipse" = "#800080",
   "clouds" = "#800080"
)

# Needs https://github.com/romainfrancois/css

rstudio_css <- function(theme) {
  message("Downloading theme '", theme, "'")
  url <- sprintf(rstudio_theme_url_template, theme)
  css <- asNamespace("css")$read_css(url)

  g <- function(sel) {
    col <- vapply(
      sel,
      FUN.VALUE = "",
      function(sel1) {
        tail(c(NA_character_, css$value[grepl(sel1, css$rule) &
                                        css$property == "color"]), 1)
      }
    )

    col <- na.omit(col)[1]

    if (is.na(col) || length(col) != 1) {
      stop("Cannot get '", sel, "' from theme '", theme, "'")
    }

    col <- sub("[ ]+!important", "", col)

    ## Three digit colors are not handled by crayon...
    if (grepl("^#[0-9a-fA-F][0-9a-fA-F][0-9a-fA-F]$", col)) {
      col <- paste(rep(strsplit(col, "")[[1]], c(1, 2, 2, 2)), collapse = "")
    }
    ## rgb () form
    if (grepl("^rgb", col)) {
      col <- gsub("[^0-9 ]", "", col)
      col <- do.call(rgb, as.list(scan(text = col, quiet = TRUE) / 255))
    }
    unname(col)
  }

  if (theme %in% names(keyword_theme_map)) {
    kw <- keyword_theme_map[[theme]]
  } else {
    kw <- g("\\.ace_keyword$|\\.ace_keyword,")
  }

  if (theme %in% names(operator_theme_map)) {
    if (is.null(operator_theme_map[[theme]])) {
      if (rstudio_theme_details_map[[theme]]$isDark) {
        op <- "#aaaaaa"
      } else {
        op <- "#888888"
      }
    } else {
      op <- operator_theme_map[[theme]]
    }
  } else {
    op <- g(c(
      "^\\.ace_keyword\\.ace_operator$",
      "^\\.ace_constant\\.ace_language$",
      "^\\.ace_variable\\.ace_language$",
      "\\.ace_constant,",
      "\\.ace_constant\\.ace_buildin"
    ))
  }

  list(
    reserved_ = kw,
    number_ = g(c("\\.ace_constant\\.ace_numeric$", "\\.ace_constant,")),
    null_ = g(c("\\.ace_constant\\.ace_language$",
                "\\.ace_variable\\.ace_language$",
                "\\.ace_constant,",
                "\\.ace_constant\\.ace_buildin")),
    operator_ = op,
    call_ = NA_character_,
    string_ = g("\\.ace_string$|\\.ace_string,"),
    comment_ = g("\\.ace_comment$|\\.ace_comment,"),
    bracket_ = g(c("\\.ace_paren\\.ace_keyword\\.ace_operator",
                   "\\.ace_keyword\\.ace_operator"))
  )
}

create_rstudio_data <- function() {

  themes <- lapply(names(rstudio_theme_details_map), rstudio_css)
  names(themes) <- names(rstudio_theme_details_map)

  # Some substitutions
  for (nm in names(operator_theme_map)) {
    if (is.null(operator_theme_map[[nm]])) {

    } else {
      themes[[nm]]$null_ <- operator_theme_map[[nm]]
      themes[[nm]]$operator_ <- operator_theme_map[[nm]]
      themes[[nm]]$bracket_ <- operator_theme_map[[nm]]
    }
  }

  for (nm in names(keyword_theme_map)) {
    themes[[nm]]$reserved_ <- keyword_theme_map[[nm]]
  }

  # check that crayon can handle these, otherwise it will error
  lapply(na.omit(unlist(themes)), crayon::make_style)

  themes2 <- lapply(themes, function(theme) {
    eval(substitute(
      function() {
        list(
          reserved = crayon::make_style(reserved_),
          number   = crayon::make_style(number_),
          null     = crayon::make_style(null_),
          operator = crayon::make_style(operator_),
          call     = crayon::bold,
          string   = crayon::make_style(string_),
          comment  = crayon::make_style(comment_),
          bracket  = list(crayon::make_style(bracket_),
                          crayon::yellow, crayon::blue, crayon::cyan)
        )
      }, theme))
    })

  names(themes2) <- vapply(rstudio_theme_details_map, "[[", "", "name")

  message("Saving sysdata.rda... ", appendLF = FALSE)
  rstudio_themes <- themes2
  save(rstudio_themes, file = file.path("R", "sysdata.rda"), version = 2)
  message("done.")

  invisible(themes2)
}

if (is.null(sys.calls())) {
  create_rstudio_data()
}

`%||%` <- function(l, r) if (is.null(l)) r else l

is_interactive <- function() interactive()

is_terminal <- function() {
  isatty(stdin()) &&
    Sys.getenv("RSTUDIO") != 1 &&
    Sys.getenv("R_GUI_APP_VERSION") == "" &&
    .Platform$GUI != "Rgui" &&
    !identical(getOption("STERM"), "iESS") &&
    Sys.getenv("EMACS") != "t"
}

context("utils")

test_that("is_interactive", {
  expect_identical(interactive(), is_interactive())
})

test_that("is_terminal, not a tty", {
  mockery::stub(is_terminal, "isatty", FALSE)
  expect_false(is_terminal())
})

test_that("is_terminal, rstudio", {
  withr::with_envvar(
    c("RSTUDIO" = "1"),
    expect_false(is_terminal())
  )
})

test_that("is_terminal, rgui", {
  withr::with_envvar(
    c("R_GUI_APP_VERSION" = "1.2.3"),
    expect_false(is_terminal())
  )
})

test_that("is_terminal, emacs", {
  withr::with_options(
    list("STERM" = "iESS"),
    expect_false(is_terminal())
  )
})

#' Default `prettycode` syntax highlighting style
#'
#' A style function must return a named list of functions. Possible
#' entries:
#' * `reserved`: reserved words
#' * `number`: numeric literals
#' * `null`: the `NULL` constant
#' * `operator`: operators, including assignment
#' * `call`: function calls
#' * `string`: character literals
#' * `comment`: comments
#' * `bracket`: brackets: \code{(){}[]} 
#'
#' Each entry in a list must be a function that takes a character
#' scalar, and returns a character scalar with the exception of `bracket`
#' which should be a list of these type of functions defining a color sequence. 
#' The default style adds ANSI formatting to the code.
#'
#' Note that you can also change the code if you like, e.g. to include
#' a unicode arrow character instead of the two-character assignment
#' operator.
#'
#' @importFrom crayon red cyan combine_styles make_style magenta bold
#'   blue green yellow italic
#' @export
#' @examples
#' highlight(deparse(get), style = default_style())

default_style <- function() {
  rs <- rstudio$detect()
  if (rs$type %in% c("rstudio_console", "rstudio_console_starting")) {
    default_style_rstudio()
  } else {
    default_style_term()
  }
}

default_style_rstudio <- function() {
  theme <- rstudioapi::getThemeInfo()$editor
  do.call(rstudio_themes[[theme]] %||% no_style, list())
}

no_style <- function() {
  list(
    reserved = identity,
    number   = identity,
    null     = identity,
    operator = identity,
    call     = identity,
    string   = identity,
    comment  = identity,
    bracket  = list(identity)
  )
}

default_style_term <- function() {
  list(
    reserved = red,
    number   = blue,
    null     = combine_styles(blue, bold),
    operator = green,
    call     = cyan,
    string   = yellow,
    comment  = combine_styles(make_style("darkgrey"), italic),
    bracket  = c(yellow, blue, cyan)
  )
}

context("style")

test_that("default_style", {
  def <- default_style()
  expect_true(is.list(def))
  expect_true(
    all(
      names(def) %in%
      c("reserved", "number", "null", "operator", "call", "string", "comment", "bracket")
    )
  )
})

replace_in_place <- function(str, start, end, replacement) {

  stopifnot(
    length(str) == 1,
    length(start) == length(end),
    length(end) == length(replacement)
  )

  keep <- substring(str, c(1, end + 1), c(start - 1, nchar(str)))

  pieces <- character(length(replacement) * 2 + 1)

  even <- seq_along(replacement) * 2
  odd <- c(1, even + 1)
  pieces[even] <- replacement
  pieces[odd] <- keep

  paste0(pieces, collapse = "")
}

context("replace_in_place")

test_that("replace_in_place", {

  expect_equal(
    replace_in_place("1234567890", c(2, 6), c(5, 8), c("foobar", "xxx")),
    "1foobarxxx90"
  )

  expect_equal(
    replace_in_place("1234567890", c(1, 5), c(6, 10), c("A", "B")),
    "AB"
  )
})

test_that("replace_in_place corner cases", {

  expect_equal(
    replace_in_place("foobar", integer(), integer(), character()),
    "foobar"
  )

  expect_equal(
    replace_in_place("12345", 1L, 5L, "no!"),
    "no!"
  )

  expect_equal(
    replace_in_place("12345", 1:5, 1:5, letters[1:5]),
    "abcde"
  )
})

rstudio <- local({

  standalone_env <- environment()
  parent.env(standalone_env) <- baseenv()

  # -- Collect data ------------------------------------------------------

  data <- NULL

  get_data <- function() {
    envs <- c(
      "R_BROWSER",
      "R_PDFVIEWER",
      "RSTUDIO",
      "RSTUDIO_TERM",
      "RSTUDIO_CONSOLE_COLOR",
      "ASCIICAST")

    d <- list(
      pid = Sys.getpid(),
      envs = Sys.getenv(envs),
      api = tryCatch(
        asNamespace("rstudioapi")$isAvailable(),
        error = function(err) FALSE
      ),
      tty = isatty(stdin()),
      gui = .Platform$GUI,
      args = commandArgs(),
      search = search()
    )
    d$ver <- if (d$api) asNamespace("rstudioapi")$getVersion()
    d$desktop <- if (d$api) asNamespace("rstudioapi")$versionInfo()$mode

    d
  }

  # -- Auto-detect environment -------------------------------------------

  is_rstudio <- function() {
    Sys.getenv("RSTUDIO") == "1"
  }

  detect <- function(clear_cache = FALSE) {
    # Cached?
    if (clear_cache) data <<- list()
    if (!is.null(data)) return(get_caps(data))

    # Otherwise get data
    new <- get_data()

    # Cache unless told otherwise
    cache <- TRUE

    new$type <- if (new$envs[["RSTUDIO"]] != "1") {
      # 1. Not RStudio at all
      "not_rstudio"

    } else if (new$gui == "RStudio" && new$api) {
      # 2. RStudio console, properly initialized
      "rstudio_console"

    } else if (new$gui == "RStudio" && ! new$api) {
      # 3. RStudio console, initilizing
      cache <- FALSE
      "rstudio_console_starting"

    } else if (new$tty && new$envs[["ASCIICAST"]] != "true") {
      # 4. R in the RStudio terminal
      # This could also be a subprocess of the console or build pane
      # with a pseudo-terminal. There isn't really a way to rule that
      # out, without inspecting some process data with ps::ps_*().
      # At least we rule out asciicast
      "rstudio_terminal"

    } else if (! new$tty &&
               new$envs[["RSTUDIO_TERM"]] == "" &&
               new$envs[["R_BROWSER"]] == "false" &&
               new$envs[["R_PDFVIEWER"]] == "false" &&
               is_build_pane_command(new$args)) {
      # 5. R in the RStudio build pane
      # https://github.com/rstudio/rstudio/blob/master/src/cpp/session/
      # modules/build/SessionBuild.cpp#L231-L240
      "rstudio_build_pane"

    } else {
      # Otherwise it is a subprocess of the console, terminal or
      # build pane, and it is hard to say which, so we do not try.
      "rstudio_subprocess"
    }

    if (cache) data <<- new

    get_caps(new)
  }

  is_build_pane_command <- function(args) {
    cmd <- gsub("[\"']", "", args[[length(args)]])
    rcmd <- sub("[(].*$", "", cmd)
    rcmd %in% c("devtools::build", "devtools::test", "devtools::check")
  }

  # -- Capabilities ------------------------------------------------------

  caps <- list()

  caps$not_rstudio <- function(data) {
    list(
      type = "not_rstudio",
      dynamic_tty = FALSE,
      ansi_tty = FALSE,
      ansi_color = FALSE,
      num_colors = 1L
    )
  }

  caps$rstudio_console <- function(data) {
    list(
      type = "rstudio_console",
      dynamic_tty = TRUE,
      ansi_tty = FALSE,
      ansi_color = data$envs[["RSTUDIO_CONSOLE_COLOR"]] != "",
      num_colors = as.integer(data$envs[["RSTUDIO_CONSOLE_COLOR"]])
    )
  }

  caps$rstudio_console_starting <- function(data) {
    res <- caps$rstudio_console(data)
    res$type <- "rstudio_console_starting"
    res
  }

  caps$rstudio_terminal <- function(data) {
    list(
      type = "rstudio_terminal",
      dynamic_tty = TRUE,
      ansi_tty = TRUE,
      ansi_color = data$envs[["RSTUDIO_CONSOLE_COLOR"]] != "",
      num_colors = as.integer(data$envs[["RSTUDIO_CONSOLE_COLOR"]])
    )
  }

  caps$rstudio_build_pane <- function(data) {
    list(
      type = "rstudio_build_pane",
      dynamic_tty = TRUE,
      ansi_tty = FALSE,
      ansi_color = data$envs[["RSTUDIO_CONSOLE_COLOR"]] != "",
      num_colors = as.integer(data$envs[["RSTUDIO_CONSOLE_COLOR"]])
    )
  }

  caps$rstudio_subprocess <- function(data) {
    list(
      type = "rstudio_subprocess",
      dynamic_tty = FALSE,
      ansi_tty = FALSE,
      ansi_color = FALSE,
      num_colors = 1L
    )
  }

  get_caps <- function(data, type = data$type) caps[[type]](data)

  structure(
    list(
      .internal = standalone_env,
      is_rstudio = is_rstudio,
      detect = detect
    ),
    class = c("standalone_rstudio_detect", "standalone")
  )
})

open_brackets <- function() {
  c("(", "{", "[")
}

close_brackets <- function(){
  c(")", "}", "]")
}

bracket_tokens <- function() {
  s <- c(open_brackets(), close_brackets())
  c(paste0("'", s, "'"), "LBB")
}

apply_color <- function(x, lvl, l){
  k <- (lvl - 1) %% length(l) + 1
  l[[k]](x)
}

#' Colored brackets
#'
#' Add color to brackets. Brackets will be coloured consecutively with the
#' colors provided in \code{color_seq} by scope.
#'
#' @param x a character vector of brackets consisting of a valid sequence of any
#'   of the following: \code{'[[', '[', ']', '(', ')', '{', '}'}
#' @param color_seq a list of functions that take and return a character scalar. The 
#' ordering defines the sequence of color functions to apply to a given scope level.
#' Color functions are recycled when the scope level exceeds the length of \code{color_seq}
#'
#' @details Meant for coloring brackets encountered within \code{highlight}.
#'   Note that occurrences of 'orphan' brackets are not taken into account
#'   mainly due to the fact that cases such as
#'
#'   \code{foo <- function(x){ `[[`(x, 1) }}
#'
#'   will either be converted to
#'
#'   \code{foo <- function(x){ x[[1]] }}
#'
#'   before the brackets are coloured if passed in as
#'   \code{highlight(deparse(foo))} or will be identified as a
#'   'SYMBOL_FUNCTION_CALL' token instead of 'LBB' if passed in as
#'
#'   \code{highlight("foo <- function(x){ `[[`(x, 1) }")}
#'
#'   Similarly, invalid code that would lead to orphaned brackets is not taken
#'   into account as this would be caught before hand in \code{highlight}.
#'
#' @keywords internal
color_brackets <- function(x, color_seq = list(yellow, blue, cyan)) {
  stopifnot(vapply(color_seq, is.function, logical(1)))
  open <- c(open_brackets(), "[[")
  o <- character() 
  lvl <- 0 
  i <- 1
  while (i <= length(x)) {
    
    if (x[i] %in% open) {
      o[length(o) + 1] <- x[i]
      lvl <- lvl + 1
      x[i] <- apply_color(x[i], lvl, color_seq)
      i <- i + 1
      next
    } 
    
    j <- nchar(o[length(o)])
    x[i:(i + j - 1)] <- 
      apply_color(x[i:(i + j - 1)], lvl, color_seq)
    i <- i + j
    lvl <- lvl - 1
    o <- o[-length(o)] 
  }
  x
}

operator_tokens <- function() {
  c(
    "'-'", "'+'", "'!'", "'~'", "'?'", "':'", "'*'", "'/'", "'^'",
    "SPECIAL", "LT", "GT", "EQ", "GE", "LE", "AND", "AND2", "OR", "OR2",
    "LEFT_ASSIGN", "RIGHT_ASSIGN", "'$'", "'@'", "EQ_ASSIGN"
  )
}

reserved_words <- function() {
  c("FUNCTION", "IF", "ELSE",
    "REPEAT", "WHILE", "FOR", "IN", "NEXT", "BREAK")
}


#' Syntax highlight R code
#'
#' @param code Character vector, each element is one line of code.
#' @param style Style functions, see [default_style()].
#' @return Character vector, the highlighted code.
#'
#' @importFrom utils getSrcref getParseData
#' @export
#' @examples
#' highlight(deparse(ls))
#' cat(highlight(deparse(ls)), sep = "\n")

highlight <- function(code, style = default_style()) {

  parsed <- parse(text = code, keep.source = TRUE)
  data <- getParseData(parsed, includeText = NA)

  hitext <- data$text

  ## Reserved words if else repeat while function for in next break
  if (!is.null(style$reserved)) {
    reserved <- data$token %in% reserved_words()
    hitext[reserved] <- style$reserved(data$text[reserved])
  }

  ## Numeric constants, including NAs, NaN and Inf
  if (!is.null(style$number)) {
    num_const <- data$token == "NUM_CONST"
    hitext[num_const] <- style$number(data$text[num_const])
  }

  ## NULL
  if (!is.null(style$null)) {
    null <- data$token == "NULL_CONST"
    hitext[null] <- style$null(data$text[null])
  }

  ## Operators
  if (!is.null(style$operator)) {
    operator <- data$token %in% operator_tokens()
    hitext[operator] <- style$operator(data$text[operator])
  }

  ## Function calls
  if (!is.null(style$call)) {
    fun_call <- data$token == "SYMBOL_FUNCTION_CALL"
    hitext[fun_call] <- style$call(data$text[fun_call])
  }

  ## Strings
  if (!is.null(style$string)) {
    string <- data$token == "STR_CONST"
    hitext[string] <- style$string(data$text[string])
  }

  ## Comments
  if (!is.null(style$comment)) {
    comment <- data$token == "COMMENT"
    hitext[comment] <- style$comment(data$text[comment])
  }
  
  ## Brackets
  if (!is.null(style$bracket)){
    bracket <- data$token %in% bracket_tokens()
    hitext[bracket] <- color_brackets(data$text[bracket], style$bracket)
  }

  do_subst(code, data, hitext)
}

do_subst <- function(code, pdata, hitext) {

  pdata$hitext <- hitext

  ## Need to do this line by line. TODO: multiline stuff might be broken
  vapply(seq_along(code), FUN.VALUE = character(1), function(no) {
    my <- pdata[pdata$line1 == no & pdata$line2 == no,, drop = FALSE]
    replace_in_place(code[no], my$col1, my$col2, my$hitext)
  })
}

context("highlight")

test_that("reserved", {

  expect_equal(
    highlight("function () { }", list(reserved = function(x) "foo")),
    "foo () { }"
  )

  expect_equal(
    highlight("if (1) NULL else NULL", list(reserved = function(x) "foo")),
    "foo (1) NULL foo NULL"
  )

  expect_equal(
    highlight("repeat {}", list(reserved = function(x) "foo")),
    "foo {}"
  )

  expect_equal(
    highlight("while (1) {}", list(reserved = function(x) "foo")),
    "foo (1) {}"
  )

  expect_equal(
    highlight("for (i in x) next", list(reserved = function(x) "foo")),
    "foo (i foo x) foo"
  )

  expect_equal(
    highlight("for (i in x) break", list(reserved = function(x) "foo")),
    "foo (i foo x) foo"
  )
})

test_that("number", {

  expect_equal(
    highlight("1 + 1.0 + -1 + 2L + Inf", list(number = function(x) "N")),
    "N + N + -N + N + N"
  )

  expect_equal(
    highlight(
      "NA + NA_real_ + NA_integer_ + NA_character_",
      list(number = function(x) "N")
    ),
    "N + N + N + N"
  )

  expect_equal(
    highlight("TRUE + FALSE", list(number = function(x) "N")),
    "N + N"
  )
})

test_that("null", {
  expect_equal(highlight("NULL", list(null = function(x) "!!!")), "!!!")
})

test_that("operator", {

  expect_equal(
    highlight(
      "~ ! 1 - 2 + 3:4 * 5 / 6 ^ 7",
      list(operator = function(x) "OP")
    ),
    "OP OP 1 OP 2 OP 3OP4 OP 5 OP 6 OP 7"
  )

  expect_equal(
    highlight(
      "? 1 %% 2 %+% 2 < 3 & 4 > 5 && 6 == 7 | 8 <= 9 || 10 >= 11",
      list(operator = function(x) "OP")
    ),
    "OP 1 OP 2 OP 2 OP 3 OP 4 OP 5 OP 6 OP 7 OP 8 OP 9 OP 10 OP 11"
  )

  expect_equal(
    highlight(
      "a <- 10; 20 -> b; c = 30; a$b; a@b",
      list(operator = function(x) "OP")
    ),
    "a OP 10; 20 OP b; c OP 30; aOPb; aOPb"
  )
})

test_that("call", {
  expect_equal(highlight("ls(2)", list(call = function(x) "F")), "F(2)")
})

test_that("string", {
  expect_equal(
    highlight("'s' + \"s\"", list(string = function(x) "S")),
    "S + S"
  )
})

test_that("comment", {
  expect_equal(
    highlight(c("# COM", " ls() ## ANOT"), list(comment = function(x) "C")),
    c("C", " ls() C")
  )
})

test_that("bracket", {
  expect_equal(
    highlight("foo <- function(x){x}", list(bracket = list(function(x) "B"))),
    "foo <- functionBxBBxB"
  )
})

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/print.R
\name{prettycode}
\alias{prettycode}
\title{Pretty Print R Code in the Terminal}
\usage{
prettycode()
}
\description{
Replace the standard print method for functions with one that performs
syntax highlighting, using ANSI colors, if the terminal supports them.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/style.R
\name{default_style}
\alias{default_style}
\title{Default \code{prettycode} syntax highlighting style}
\usage{
default_style()
}
\description{
A style function must return a named list of functions. Possible
entries:
\itemize{
\item \code{reserved}: reserved words
\item \code{number}: numeric literals
\item \code{null}: the \code{NULL} constant
\item \code{operator}: operators, including assignment
\item \code{call}: function calls
\item \code{string}: character literals
\item \code{comment}: comments
\item \code{bracket}: brackets: \code{(){}[]}
}
}
\details{
Each entry in a list must be a function that takes a character
scalar, and returns a character scalar with the exception of \code{bracket}
which should be a list of functions defining a color sequence. The default style adds
ANSI formatting to the code.

Note that you can also change the code if you like, e.g. to include
a unicode arrow character instead of the two-character assignment
operator.
}
\examples{
highlight(deparse(get), style = default_style())
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/brackets.R
\name{color_brackets}
\alias{color_brackets}
\title{Colored brackets}
\usage{
color_brackets(x, color_seq = list(yellow, blue, cyan))
}
\arguments{
\item{x}{a character vector of brackets consisting of a valid sequence of any
of the following: \code{'[[', '[', ']', '(', ')', '{', '}'}}

\item{color_seq}{a list of functions that take and return a character scalar}
}
\description{
Add color to brackets. Brackets will be coloured consecutively with the
colors provided in \code{color_seq} by scope.
}
\details{
Meant for coloring brackets encountered within \code{highlight}.
Note that occurrences of 'orphan' brackets are not taken into account
mainly due to the fact that cases such as

\code{foo <- function(x){ `[`(x, 1) }}

will either be converted to

\code{foo <- function(x){ x[1]}}

before the brackets are coloured if passed in as
\code{highlight(deparse(foo))} or will be identified as a
'SYMBOL_FUNCTION_CALL' token instead of 'LBB' if passed in as

\code{highlight("foo <- function(x){ `[`(x, 1) }")}

Similarly, invalid code that would lead to orphaned brackets is not taken
into account as this would be caught before hand in \code{highlight}.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/print.R
\name{print.function}
\alias{print.function}
\title{Print a function with syntax highlighting}
\usage{
\method{print}{function}(x, useSource = TRUE, style = default_style(),
  ...)
}
\arguments{
\item{x}{Function to print.}

\item{useSource}{Whether to use the stored source code, if available.}

\item{style}{The highlight style to use, see \code{\link[=default_style]{default_style()}}.}

\item{...}{Not used currently, for compatibility with the \code{print}
generic.}
}
\value{
The function, invisibly.
}
\description{
To turn on pretty printing of functions, you need to call
\code{prettycode::prettycode()}. It might be a good idea to call it
from your \code{.Rprofile}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/highlight.R
\name{highlight}
\alias{highlight}
\title{Syntax highlight R code}
\usage{
highlight(code, style = default_style())
}
\arguments{
\item{code}{Character vector, each element is one line of code.}

\item{style}{Style functions, see \code{\link[=default_style]{default_style()}}.}
}
\value{
Character vector, the highlighted code.
}
\description{
Syntax highlight R code
}
\examples{
highlight(deparse(ls))
cat(highlight(deparse(ls)), sep = "\\n")
}
